Package org.optaplanner.core.impl.score.buildin.hardmediumsoftbigdecimal

## Class HardMediumSoftBigDecimalScoreHolderImpl

- java.lang.Object
- - org.optaplanner.core.impl.score.holder.AbstractScoreHolder<HardMediumSoftBigDecimalScore>
  - - org.optaplanner.core.impl.score.buildin.hardmediumsoftbigdecimal.HardMediumSoftBigDecimalScoreHolderImpl

- All Implemented Interfaces:
    `HardMediumSoftBigDecimalScoreHolder`, `ScoreHolder<HardMediumSoftBigDecimalScore>`

      public final class HardMediumSoftBigDecimalScoreHolderImpl
      extends AbstractScoreHolder<HardMediumSoftBigDecimalScore>
      implements HardMediumSoftBigDecimalScoreHolder

  See Also:
    `HardMediumSoftBigDecimalScore`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `AbstractScoreHolder.BigDecimalMatchExecutor, AbstractScoreHolder.ConstraintActivationUnMatchListener, AbstractScoreHolder.IntMatchExecutor, AbstractScoreHolder.LongMatchExecutor, AbstractScoreHolder.ScoreMatchExecutor<Score_ extends AbstractScore<Score_>>`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected BigDecimal` | `hardScore` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.BigDecimalMatchExecutor>` | `matchExecutorByNumberMap` |
    `protected Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardMediumSoftBigDecimalScore>>` | `matchExecutorByScoreMap` | Slower than `matchExecutorByNumberMap`
    `protected BigDecimal` | `mediumScore` |
    `protected BigDecimal` | `softScore` |

    - ### Fields inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `constraintMatchEnabled, constraintMatchTotalMap, indictmentMap, zeroScore`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `HardMediumSoftBigDecimalScoreHolderImpl​(boolean constraintMatchEnabled)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeight)` | Add a hard constraint of specified weighting.
    `void` | `addMediumConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal mediumWeight)` | Add a medium level constraint of specified weighting.
    `void` | `addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeight, BigDecimal mediumWeight, BigDecimal softWeight)` |
    `void` | `addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal softWeight)` | Add a soft constraint match of specified weighting.
    `void` | `configureConstraintWeight​(org.kie.api.definition.rule.Rule rule, HardMediumSoftBigDecimalScore constraintWeight)` |
    `HardMediumSoftBigDecimalScore` | `extractScore​(int initScore)` |
    `BigDecimal` | `getHardScore()` |
    `BigDecimal` | `getMediumScore()` |
    `BigDecimal` | `getSoftScore()` |
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, int weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, long weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `impactScore​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | For internal use only, use penalize() or reward() instead.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext)` | Penalize a match by the `ConstraintWeight` negated.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
    `void` | `penalize​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeightMultiplier, BigDecimal mediumWeightMultiplier, BigDecimal softWeightMultiplier)` | Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext)` | Reward a match by the `ConstraintWeight`.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal weightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
    `void` | `reward​(org.kie.api.runtime.rule.RuleContext kcontext, BigDecimal hardWeightMultiplier, BigDecimal mediumWeightMultiplier, BigDecimal softWeightMultiplier)` | Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level.

    - ### Methods inherited from class org.optaplanner.core.impl.score.holder.AbstractScoreHolder

      `extractJustificationList, getConstraintMatchTotalMap, getIndictmentMap, isConstraintMatchEnabled, registerConstraintMatch`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### matchExecutorByNumberMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.BigDecimalMatchExecutor> matchExecutorByNumberMap

    - #### matchExecutorByScoreMap

          protected final Map<org.kie.api.definition.rule.Rule,​AbstractScoreHolder.ScoreMatchExecutor<HardMediumSoftBigDecimalScore>> matchExecutorByScoreMap

      Slower than `matchExecutorByNumberMap`

    - #### hardScore

          protected BigDecimal hardScore

    - #### mediumScore

          protected BigDecimal mediumScore

    - #### softScore

          protected BigDecimal softScore

  - ### Constructor Detail

    - #### HardMediumSoftBigDecimalScoreHolderImpl

          public HardMediumSoftBigDecimalScoreHolderImpl​(boolean constraintMatchEnabled)

  - ### Method Detail

    - #### getHardScore

          public BigDecimal getHardScore()

    - #### getMediumScore

          public BigDecimal getMediumScore()

    - #### getSoftScore

          public BigDecimal getSoftScore()

    - #### configureConstraintWeight

          public void configureConstraintWeight​(org.kie.api.definition.rule.Rule rule,
                                                HardMediumSoftBigDecimalScore constraintWeight)

      Overrides:
        `configureConstraintWeight` in class `AbstractScoreHolder<HardMediumSoftBigDecimalScore>`

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Penalize a match by the `ConstraintWeight` negated.
      Specified by:
        `penalize` in interface `ScoreHolder<HardMediumSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               BigDecimal weightMultiplier)

      Description copied from interface: `HardMediumSoftBigDecimalScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the weightMultiplier for all score levels.
      Specified by:
        `penalize` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### penalize

          public void penalize​(org.kie.api.runtime.rule.RuleContext kcontext,
                               BigDecimal hardWeightMultiplier,
                               BigDecimal mediumWeightMultiplier,
                               BigDecimal softWeightMultiplier)

      Description copied from interface: `HardMediumSoftBigDecimalScoreHolder`
      Penalize a match by the `ConstraintWeight` negated and multiplied with the specific weightMultiplier per score level. Slower than `HardMediumSoftBigDecimalScoreHolder.penalize(RuleContext, BigDecimal)`.
      Specified by:
        `penalize` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `mediumWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from interface: `ScoreHolder`
      Reward a match by the `ConstraintWeight`.
      Specified by:
        `reward` in interface `ScoreHolder<HardMediumSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null, the magic variable in DRL

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             BigDecimal weightMultiplier)

      Description copied from interface: `HardMediumSoftBigDecimalScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the weightMultiplier for all score levels.
      Specified by:
        `reward` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `weightMultiplier` - at least 0

    - #### reward

          public void reward​(org.kie.api.runtime.rule.RuleContext kcontext,
                             BigDecimal hardWeightMultiplier,
                             BigDecimal mediumWeightMultiplier,
                             BigDecimal softWeightMultiplier)

      Description copied from interface: `HardMediumSoftBigDecimalScoreHolder`
      Reward a match by the `ConstraintWeight` multiplied with the specific weightMultiplier per score level. Slower than `HardMediumSoftBigDecimalScoreHolder.reward(RuleContext, BigDecimal)`.
      Specified by:
        `reward` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeightMultiplier` - at least 0
        `mediumWeightMultiplier` - at least 0
        `softWeightMultiplier` - at least 0

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Overrides:
        `impactScore` in class `AbstractScoreHolder<HardMediumSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  int weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardMediumSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  long weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardMediumSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### impactScore

          public void impactScore​(org.kie.api.runtime.rule.RuleContext kcontext,
                                  BigDecimal weightMultiplier)

      Description copied from class: `AbstractScoreHolder`
      For internal use only, use penalize() or reward() instead.
      Specified by:
        `impactScore` in interface `HardMediumSoftBigDecimalScoreHolder`
      Specified by:
        `impactScore` in class `AbstractScoreHolder<HardMediumSoftBigDecimalScore>`
      Parameters:
        `kcontext` - never null
        `weightMultiplier` - any

    - #### addHardConstraintMatch

          public void addHardConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             BigDecimal hardWeight)

      Description copied from interface: `HardMediumSoftBigDecimalScoreHolder`
      Add a hard constraint of specified weighting. This is typically used in Drools scoring to add a hard constraint match (negative value to indicate an infeasible solution).
      Specified by:
        `addHardConstraintMatch` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### addMediumConstraintMatch

          public void addMediumConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                               BigDecimal mediumWeight)

      Description copied from interface: `HardMediumSoftBigDecimalScoreHolder`
      Add a medium level constraint of specified weighting. This is typically used in Drools scoring to add a medium priority constraint match.
      Specified by:
        `addMediumConstraintMatch` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `mediumWeight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### addSoftConstraintMatch

          public void addSoftConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                             BigDecimal softWeight)

      Description copied from interface: `HardMediumSoftBigDecimalScoreHolder`
      Add a soft constraint match of specified weighting. This is typically used in Drools scoring to add a low priority constraint match.
      Specified by:
        `addSoftConstraintMatch` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `softWeight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### addMultiConstraintMatch

          public void addMultiConstraintMatch​(org.kie.api.runtime.rule.RuleContext kcontext,
                                              BigDecimal hardWeight,
                                              BigDecimal mediumWeight,
                                              BigDecimal softWeight)

      Specified by:
        `addMultiConstraintMatch` in interface `HardMediumSoftBigDecimalScoreHolder`
      Parameters:
        `kcontext` - never null, the magic variable in DRL
        `hardWeight` - never null, higher is better, negative for a penalty, positive for a reward
        `mediumWeight` - never null, higher is better, negative for a penalty, positive for a reward
        `softWeight` - never null, higher is better, negative for a penalty, positive for a reward

    - #### extractScore

          public HardMediumSoftBigDecimalScore extractScore​(int initScore)

      Specified by:
        `extractScore` in class `AbstractScoreHolder<HardMediumSoftBigDecimalScore>`